Index: trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 2528)
@@ -8,4 +8,6 @@
    !!             -   !  2007-01  (D. Storkey) Tidal forcing
    !!            3.0  !  2008-04  (NEMO team)  add in the reference version
+   !!            3.3  !  2010-09  (E.O'Dea) updates for Shelf configurations
+   !!            3.3  !  2010-09  (D.Storkey) add ice boundary conditions
    !!----------------------------------------------------------------------
 #if defined key_bdy
@@ -17,4 +19,5 @@
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain
+   USE obc_par         ! ocean open boundary conditions
    USE bdy_oce         ! unstructured open boundary conditions
    USE bdytides        ! tides at open boundaries initialization (tide_init routine)
@@ -30,9 +33,8 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.0 , LOCEAN-IPSL (2008) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!---------------------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
    
@@ -48,5 +50,4 @@
       !!
       !! ** Input   :  bdy_init.nc, input file for unstructured open boundaries
-      !!
       !!----------------------------------------------------------------------      
       INTEGER ::   ii, ij, ik, igrd, ib, ir   ! dummy loop indices
@@ -54,6 +55,6 @@
       INTEGER ::   ib_len, ibr_max
       INTEGER ::   iw, ie, is, in 
-      INTEGER ::   inum                 ! temporary logical unit
-      INTEGER ::   id_dummy             ! temporary integers
+      INTEGER ::   inum                 ! local logical unit
+      INTEGER ::   id_dummy             ! local integers
       INTEGER ::   igrd_start, igrd_end ! start and end of loops on igrd
       INTEGER, DIMENSION (2)             ::   kdimsz
@@ -63,10 +64,11 @@
       REAL(wp) , DIMENSION(jpidta,jpjdta) ::   zmask           ! global domain mask
       REAL(wp) , DIMENSION(jpbdta,1)      ::   zdta            ! temporary array 
-      CHARACTER(LEN=80),DIMENSION(3)      ::   clfile
+      CHARACTER(LEN=80),DIMENSION(6)      ::   clfile
       !!
-      NAMELIST/nambdy/filbdy_mask, filbdy_data_T, filbdy_data_U, filbdy_data_V,          &
-         &            ln_bdy_tides, ln_bdy_clim, ln_bdy_vol, ln_bdy_mask,                &
-         &            ln_bdy_dyn_fla, ln_bdy_dyn_frs, ln_bdy_tra_frs,                    &
-         &            nbdy_dta   , nb_rimwidth  , volbdy
+      NAMELIST/nambdy/cn_mask, cn_dta_frs_T, cn_dta_frs_U, cn_dta_frs_V,          &
+         &            cn_dta_fla_T, cn_dta_fla_U, cn_dta_fla_V,              &
+         &            ln_tides, ln_clim, ln_vol, ln_mask,                &
+         &            ln_dyn_fla, ln_dyn_frs, ln_tra_frs,ln_ice_frs,     &
+         &            nn_dtactl, nn_rimwidth, nn_volctl
       !!----------------------------------------------------------------------
 
@@ -75,80 +77,71 @@
       IF(lwp) WRITE(numout,*) '~~~~~~~~'
       !
-      IF( jperio /= 0 ) CALL ctl_stop( 'Cyclic or symmetric,',   &
-           ' and unstructured open boundary condition are not compatible' )
-
-#if defined key_obc
-      CALL ctl_stop( 'Straight open boundaries,',   &
-           ' and unstructured open boundaries are not compatible' )
-#endif
-
-      ! Read namelist parameters
+      IF( jperio /= 0 )   CALL ctl_stop( 'Cyclic or symmetric,',   &
+         &                               ' and unstructured open boundary condition are not compatible' )
+
+      IF( lk_obc      )   CALL ctl_stop( 'Straight open boundaries,',   &
+         &                               ' and unstructured open boundaries are not compatible' )
+
       ! ---------------------------
-      REWIND( numnam )
+      REWIND( numnam )                    ! Read namelist parameters
       READ  ( numnam, nambdy )
 
-      ! control prints
+      !                                   ! control prints
       IF(lwp) WRITE(numout,*) '         nambdy'
 
-      ! Check nbdy_dta value
-      IF(lwp) WRITE(numout,*) 'nbdy_dta =', nbdy_dta      
-      IF(lwp) WRITE(numout,*) ' '
-      SELECT CASE( nbdy_dta )
-      CASE( 0 )
-        IF(lwp) WRITE(numout,*) '         initial state used for bdy data'        
-      CASE( 1 )
-        IF(lwp) WRITE(numout,*) '         boundary data taken from file'
-      CASE DEFAULT
-        CALL ctl_stop( 'nbdy_dta must be 0 or 1' )
+      !                                         ! check type of data used (nn_dtactl value)
+      IF(lwp) WRITE(numout,*) 'nn_dtactl =', nn_dtactl      
+      IF(lwp) WRITE(numout,*)
+      SELECT CASE( nn_dtactl )                   ! 
+      CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      initial state used for bdy data'        
+      CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      boundary data taken from file'
+      CASE DEFAULT   ;   CALL ctl_stop( 'nn_dtactl must be 0 or 1' )
       END SELECT
 
-      IF(lwp) WRITE(numout,*) ' '
-      IF(lwp) WRITE(numout,*) 'Boundary rim width for the FRS nb_rimwidth = ', nb_rimwidth
-
-      IF(lwp) WRITE(numout,*) ' '
-      IF(lwp) WRITE(numout,*) '         volbdy = ', volbdy
-
-      IF (ln_bdy_vol) THEN
-        SELECT CASE ( volbdy ) ! Check volbdy value
-        CASE( 1 )
-          IF(lwp) WRITE(numout,*) '         The total volume will be constant'
-        CASE( 0 )
-          IF(lwp) WRITE(numout,*) '         The total volume will vary according'
-          IF(lwp) WRITE(numout,*) '         to the surface E-P flux'
-        CASE DEFAULT
-          CALL ctl_stop( 'volbdy must be 0 or 1' )
-        END SELECT
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) 'Boundary rim width for the FRS nn_rimwidth = ', nn_rimwidth
+
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) '      nn_volctl = ', nn_volctl
+
+      IF( ln_vol ) THEN                     ! check volume conservation (nn_volctl value)
+         SELECT CASE ( nn_volctl )
+         CASE( 1 )      ;   IF(lwp) WRITE(numout,*) '      The total volume will be constant'
+         CASE( 0 )      ;   IF(lwp) WRITE(numout,*) '      The total volume will vary according to the surface E-P flux'
+         CASE DEFAULT   ;   CALL ctl_stop( 'nn_volctl must be 0 or 1' )
+         END SELECT
+         IF(lwp) WRITE(numout,*)
       ELSE
-        IF(lwp) WRITE(numout,*) 'No volume correction with unstructured open boundaries'
-        IF(lwp) WRITE(numout,*) ' '
-      ENDIF
-
-      IF (ln_bdy_tides) THEN
-        IF(lwp) WRITE(numout,*) ' '
+         IF(lwp) WRITE(numout,*) 'No volume correction with unstructured open boundaries'
+         IF(lwp) WRITE(numout,*)
+      ENDIF
+
+      IF( ln_tides ) THEN
         IF(lwp) WRITE(numout,*) 'Tidal harmonic forcing at unstructured open boundaries'
-        IF(lwp) WRITE(numout,*) ' '
-      ENDIF
-
-      IF (ln_bdy_dyn_fla) THEN
-        IF(lwp) WRITE(numout,*) ' '
+        IF(lwp) WRITE(numout,*)
+      ENDIF
+
+      IF( ln_dyn_fla ) THEN
         IF(lwp) WRITE(numout,*) 'Flather condition on U, V at unstructured open boundaries'
-        IF(lwp) WRITE(numout,*) ' '
-      ENDIF
-
-      IF (ln_bdy_dyn_frs) THEN
-        IF(lwp) WRITE(numout,*) ' '
+        IF(lwp) WRITE(numout,*)
+      ENDIF
+
+      IF( ln_dyn_frs ) THEN
         IF(lwp) WRITE(numout,*) 'FRS condition on U and V at unstructured open boundaries'
-        IF(lwp) WRITE(numout,*) ' '
-      ENDIF
-
-      IF (ln_bdy_tra_frs) THEN
-        IF(lwp) WRITE(numout,*) ' '
+        IF(lwp) WRITE(numout,*)
+      ENDIF
+
+      IF( ln_tra_frs ) THEN
         IF(lwp) WRITE(numout,*) 'FRS condition on T & S fields at unstructured open boundaries'
-        IF(lwp) WRITE(numout,*) ' '
-      ENDIF
-
-      ! Read tides namelist 
-      ! ------------------------
-      IF( ln_bdy_tides )   CALL tide_init
+        IF(lwp) WRITE(numout,*)
+      ENDIF
+
+      IF( ln_ice_frs ) THEN
+        IF(lwp) WRITE(numout,*) 'FRS condition on ice fields at unstructured open boundaries'
+        IF(lwp) WRITE(numout,*)
+      ENDIF
+
+      IF( ln_tides )   CALL tide_init      ! Read tides namelist 
+
 
       ! Read arrays defining unstructured open boundaries
@@ -160,9 +153,9 @@
       !          = 0  elsewhere   
  
-      IF( cp_cfg == "eel" .AND. jp_cfg == 5 ) THEN
+      IF( cp_cfg == "eel" .AND. jp_cfg == 5 ) THEN          ! EEL configuration at 5km resolution
          zmask(         :                ,:) = 0.e0
          zmask(jpizoom+1:jpizoom+jpiglo-2,:) = 1.e0          
-      ELSE IF ( ln_bdy_mask ) THEN
-         CALL iom_open( filbdy_mask, inum )
+      ELSE IF( ln_mask ) THEN
+         CALL iom_open( cn_mask, inum )
          CALL iom_get ( inum, jpdom_data, 'bdy_msk', zmask(:,:) )
          CALL iom_close( inum )
@@ -171,6 +164,5 @@
       ENDIF
 
-      ! Save mask over local domain      
-      DO ij = 1, nlcj
+      DO ij = 1, nlcj      ! Save mask over local domain      
          DO ii = 1, nlci
             bdytmask(ii,ij) = zmask( mig(ii), mjg(ij) )
@@ -187,8 +179,6 @@
          END DO
       END DO
-
-      ! Lateral boundary conditions
-      CALL lbc_lnk( bdyumask(:,:), 'U', 1. )
-      CALL lbc_lnk( bdyvmask(:,:), 'V', 1. )
+      CALL lbc_lnk( bdyumask(:,:), 'U', 1. )   ;   CALL lbc_lnk( bdyvmask(:,:), 'V', 1. )      ! Lateral boundary cond.
+
 
       ! Read discrete distance and mapping indices
@@ -200,18 +190,16 @@
       IF( cp_cfg == "eel" .AND. jp_cfg == 5 ) THEN
          icount = 0
-         ! Define west boundary (from ii=2 to ii=1+nb_rimwidth):
-         DO ir = 1, nb_rimwidth         
+         DO ir = 1, nn_rimwidth                  ! Define west boundary (from ii=2 to ii=1+nn_rimwidth):
             DO ij = 3, jpjglo-2
-               icount=icount+1
+               icount = icount + 1
                nbidta(icount,:) = ir + 1 + (jpizoom-1)
-               nbjdta(icount,:) = ij + (jpjzoom-1) 
+               nbjdta(icount,:) = ij     + (jpjzoom-1) 
                nbrdta(icount,:) = ir
             END DO
          END DO
-
-         ! Define east boundary (from ii=jpiglo-1 to ii=jpiglo-nb_rimwidth):
-         DO ir=1,nb_rimwidth         
+         !
+         DO ir = 1, nn_rimwidth                  ! Define east boundary (from ii=jpiglo-1 to ii=jpiglo-nn_rimwidth):
             DO ij=3,jpjglo-2
-               icount=icount+1
+               icount = icount + 1
                nbidta(icount,:) = jpiglo-ir + (jpizoom-1)
                nbidta(icount,2) = jpiglo-ir-1 + (jpizoom-1) ! special case for u points
@@ -220,30 +208,42 @@
             END DO
          END DO
-            
+         !       
       ELSE            ! Read indices and distances in unstructured boundary data files 
-
-         IF( ln_bdy_tides ) THEN 
-            ! Read tides input files for preference in case there are
-            ! no bdydata files. 
-            clfile(1) = TRIM(filtide)//TRIM(tide_cpt(1))//'_grid_T.nc'
-            clfile(2) = TRIM(filtide)//TRIM(tide_cpt(1))//'_grid_U.nc'
-            clfile(3) = TRIM(filtide)//TRIM(tide_cpt(1))//'_grid_V.nc'
-         ELSE
-            clfile(1) = filbdy_data_T
-            clfile(2) = filbdy_data_U
-            clfile(3) = filbdy_data_V
+         !
+         IF( ln_tides ) THEN             ! Read tides input files for preference in case there are no bdydata files
+            clfile(4) = TRIM(filtide)//TRIM(tide_cpt(1))//'_grid_T.nc'
+            clfile(5) = TRIM(filtide)//TRIM(tide_cpt(1))//'_grid_U.nc'
+            clfile(6) = TRIM(filtide)//TRIM(tide_cpt(1))//'_grid_V.nc'
+         ENDIF
+         IF( ln_dyn_fla .AND. .NOT. ln_tides ) THEN 
+            clfile(4) = cn_dta_fla_T
+            clfile(5) = cn_dta_fla_U
+            clfile(6) = cn_dta_fla_V
+         ENDIF
+
+         IF( ln_tra_frs ) THEN 
+            clfile(1) = cn_dta_frs_T
+            IF( .NOT. ln_dyn_frs ) THEN 
+               clfile(2) = cn_dta_frs_T     ! Dummy read re read T file for sake of 6 files
+               clfile(3) = cn_dta_frs_T     !
+            ENDIF
          ENDIF          
-
-         ! how many files are we to read in?
-         igrd_start = 1
-         igrd_end   = 3
-         IF(.NOT. ln_bdy_tides ) THEN
-            IF(.NOT. (ln_bdy_dyn_fla) .AND..NOT. (ln_bdy_tra_frs)) THEN
-               ! No T-grid file.
-               igrd_start = 2
-            ELSEIF ( .NOT. ln_bdy_dyn_frs .AND..NOT. ln_bdy_dyn_fla ) THEN
-               ! No U-grid or V-grid file.
-               igrd_end   = 1         
-            ENDIF
+         IF( ln_dyn_frs ) THEN 
+            IF( .NOT. ln_tra_frs )   clfile(1) = cn_dta_frs_U      ! Dummy Read 
+            clfile(2) = cn_dta_frs_U
+            clfile(3) = cn_dta_frs_V 
+         ENDIF
+
+         !                                   ! how many files are we to read in?
+         IF(ln_tides .OR. ln_dyn_fla)   igrd_start = 4
+         !
+         IF(ln_tra_frs    ) THEN   ;   igrd_start = 1
+         ELSEIF(ln_dyn_frs) THEN   ;   igrd_start = 2
+         ENDIF
+         !
+         IF( ln_tra_frs   )   igrd_end = 1
+         !
+         IF(ln_dyn_fla .OR. ln_tides) THEN   ;   igrd_end = 6
+         ELSEIF( ln_dyn_frs             ) THEN   ;   igrd_end = 3
          ENDIF
 
@@ -251,10 +251,8 @@
             CALL iom_open( clfile(igrd), inum )
             id_dummy = iom_varid( inum, 'nbidta', kdimsz=kdimsz )  
-            WRITE(numout,*) 'kdimsz : ',kdimsz
+            IF(lwp) WRITE(numout,*) 'kdimsz : ',kdimsz
             ib_len = kdimsz(1)
-            IF( ib_len > jpbdta) CALL ctl_stop(          &
-                'Boundary data array in file too long.', &
-                'File :', TRIM(clfile(igrd)),            &
-                'increase parameter jpbdta.' )
+            IF( ib_len > jpbdta)   CALL ctl_stop(  'Boundary data array in file too long.',                  &
+                &                                  'File :', TRIM(clfile(igrd)),'increase parameter jpbdta.' )
 
             CALL iom_get( inum, jpdom_unknown, 'nbidta', zdta(1:ib_len,:) )
@@ -264,19 +262,19 @@
             CALL iom_get( inum, jpdom_unknown, 'nbjdta', zdta(1:ib_len,:) )
             DO ii = 1,ib_len
-              nbjdta(ii,igrd) = INT( zdta(ii,1) )
-            END DO
-            CALL iom_get ( inum, jpdom_unknown, 'nbrdta', zdta(1:ib_len,:) )
+               nbjdta(ii,igrd) = INT( zdta(ii,1) )
+            END DO
+            CALL iom_get( inum, jpdom_unknown, 'nbrdta', zdta(1:ib_len,:) )
             DO ii = 1,ib_len
-              nbrdta(ii,igrd) = INT( zdta(ii,1) )
+               nbrdta(ii,igrd) = INT( zdta(ii,1) )
             END DO
             CALL iom_close( inum )
 
-            ! Check that rimwidth in file is big enough:
-            ibr_max = MAXVAL( nbrdta(:,igrd) )
-            IF(lwp) WRITE(numout,*)
-            IF(lwp) WRITE(numout,*) ' Maximum rimwidth in file is ', ibr_max
-            IF(lwp) WRITE(numout,*) ' nb_rimwidth from namelist is ', nb_rimwidth
-            IF (ibr_max < nb_rimwidth) CALL ctl_stop( &
-                'nb_rimwidth is larger than maximum rimwidth in file' )
+            IF( igrd < 4) THEN            ! Check that rimwidth in file is big enough for Frs case(barotropic is one):
+               ibr_max = MAXVAL( nbrdta(:,igrd) )
+               IF(lwp) WRITE(numout,*)
+               IF(lwp) WRITE(numout,*) ' Maximum rimwidth in file is ', ibr_max
+               IF(lwp) WRITE(numout,*) ' nn_rimwidth from namelist is ', nn_rimwidth
+               IF (ibr_max < nn_rimwidth)   CALL ctl_stop( 'nn_rimwidth is larger than maximum rimwidth in file' )
+            ENDIF !Check igrd < 4
             !
          END DO
@@ -293,19 +291,19 @@
 
       DO igrd = igrd_start, igrd_end
-        icount  = 0
-        icountr = 0
-        nblen(igrd) = 0
-        nblenrim(igrd) = 0
-        nblendta(igrd) = 0
-        DO ir=1, nb_rimwidth
-          DO ib = 1, jpbdta
-          ! check if point is in local domain and equals ir
-            IF(  nbidta(ib,igrd) >= iw .AND. nbidta(ib,igrd) <= ie .AND.   &
-               & nbjdta(ib,igrd) >= is .AND. nbjdta(ib,igrd) <= in .AND.   &
-               & nbrdta(ib,igrd) == ir  ) THEN
-               !
-               icount = icount  + 1
-               !
-               IF( ir == 1 )   icountr = icountr+1
+         icount  = 0
+         icountr = 0
+         nblen   (igrd) = 0
+         nblenrim(igrd) = 0
+         nblendta(igrd) = 0
+         DO ir=1, nn_rimwidth
+            DO ib = 1, jpbdta
+               ! check if point is in local domain and equals ir
+               IF(  nbidta(ib,igrd) >= iw .AND. nbidta(ib,igrd) <= ie .AND.   &
+                  & nbjdta(ib,igrd) >= is .AND. nbjdta(ib,igrd) <= in .AND.   &
+                  & nbrdta(ib,igrd) == ir  ) THEN
+                  !
+                  icount = icount  + 1
+                  !
+                  IF( ir == 1 )   icountr = icountr+1
                   IF (icount > jpbdim) THEN
                      IF(lwp) WRITE(numout,*) 'bdy_ini: jpbdim too small'
@@ -328,10 +326,7 @@
       DO igrd = igrd_start, igrd_end
          DO ib = 1, nblen(igrd)
-            ! tanh formulation
-            nbw(ib,igrd) = 1.- TANH( FLOAT( nbr(ib,igrd) - 1 ) *0.5 )
-            ! quadratic
-!           nbw(ib,igrd) = (FLOAT(nb_rimwidth+1-nbr(ib,igrd))/FLOAT(nb_rimwidth))**2
-            ! linear
-!           nbw(ib,igrd) =  FLOAT(nb_rimwidth+1-nbr(ib,igrd))/FLOAT(nb_rimwidth)
+            nbw(ib,igrd) = 1.- TANH( FLOAT( nbr(ib,igrd) - 1 ) *0.5 )                     ! tanh formulation
+!           nbw(ib,igrd) = (FLOAT(nn_rimwidth+1-nbr(ib,igrd))/FLOAT(nn_rimwidth))**2      ! quadratic
+!           nbw(ib,igrd) =  FLOAT(nn_rimwidth+1-nbr(ib,igrd))/FLOAT(nn_rimwidth)          ! linear
          END DO
       END DO 
@@ -384,10 +379,8 @@
 
       ! Lateral boundary conditions
-      CALL lbc_lnk( fmask        , 'F', 1. )
-      CALL lbc_lnk( bdytmask(:,:), 'T', 1. )
-      CALL lbc_lnk( bdyumask(:,:), 'U', 1. )
-      CALL lbc_lnk( bdyvmask(:,:), 'V', 1. )
-
-      IF( ln_bdy_vol .OR. ln_bdy_dyn_fla ) THEN      ! Indices and directions of rim velocity components
+      CALL lbc_lnk( fmask        , 'F', 1. )   ;   CALL lbc_lnk( bdytmask(:,:), 'T', 1. )
+      CALL lbc_lnk( bdyumask(:,:), 'U', 1. )   ;   CALL lbc_lnk( bdyvmask(:,:), 'V', 1. )
+
+      IF( ln_vol .OR. ln_dyn_fla ) THEN      ! Indices and directions of rim velocity components
          !
          !flagu = -1 : u component is normal to the dynamical boundary but its direction is outward
@@ -437,7 +430,6 @@
       ! Compute total lateral surface for volume correction:
       ! ----------------------------------------------------
- 
       bdysurftot = 0.e0 
-      IF( ln_bdy_vol ) THEN  
+      IF( ln_vol ) THEN  
          igrd = 2      ! Lateral surface at U-points
          DO ib = 1, nblenrim(igrd)
@@ -455,5 +447,5 @@
                &                    * tmask_i(nbi(ib,igrd),nbj(ib,igrd)+1)
          END DO
-
+         !
          IF( lk_mpp )   CALL mpp_sum( bdysurftot )      ! sum over the global domain
       END IF   
@@ -468,8 +460,13 @@
       ubtbdy(:) = 0.e0
       vbtbdy(:) = 0.e0
+#if defined key_lim2
+      frld_bdy(:) = 0.e0
+      hicif_bdy(:) = 0.e0
+      hsnif_bdy(:) = 0.e0
+#endif
 
       ! Read in tidal constituents and adjust for model start time
       ! ----------------------------------------------------------
-      IF( ln_bdy_tides )   CALL tide_data
+      IF( ln_tides )   CALL tide_data
       !
    END SUBROUTINE bdy_init
Index: trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdytides.F90	(revision 2528)
@@ -7,4 +7,5 @@
    !!            2.3  !  2008-01  (J.Holt)  Add date correction. Origins POLCOMS v6.3 2007
    !!            3.0  !  2008-04  (NEMO team)  add in the reference version
+   !!            3.3  !  2010-09  (D.Storkey and E.O'Dea)  bug fixes
    !!----------------------------------------------------------------------
 #if defined key_bdy
@@ -31,4 +32,5 @@
    USE bdy_par         ! Unstructured boundary parameters
    USE bdy_oce         ! ocean open boundary conditions
+   USE daymod          ! calendar
 
    IMPLICIT NONE
@@ -39,25 +41,23 @@
    PUBLIC   tide_update   ! routine called in bdydyn
 
-   LOGICAL, PUBLIC            ::   ln_tide_date            !: =T correct tide phases and amplitude for model start date
-
-   INTEGER, PARAMETER ::   jptides_max = 15      !: Max number of tidal contituents
-   INTEGER            ::   ntide                 !: Actual number of tidal constituents
+   LOGICAL, PUBLIC            ::   ln_tide_date          !: =T correct tide phases and amplitude for model start date
+   INTEGER, PUBLIC, PARAMETER ::   jptides_max = 15      !: Max number of tidal contituents
+   INTEGER, PUBLIC            ::   ntide                 !: Actual number of tidal constituents
 
    CHARACTER(len=80), PUBLIC                         ::   filtide    !: Filename root for tidal input files
    CHARACTER(len= 4), PUBLIC, DIMENSION(jptides_max) ::   tide_cpt   !: Names of tidal components used.
 
-   INTEGER , DIMENSION(jptides_max) ::   nindx        !: ???
-   REAL(wp), DIMENSION(jptides_max) ::   tide_speed   !: Phase speed of tidal constituent (deg/hr)
+   INTEGER , PUBLIC, DIMENSION(jptides_max) ::   nindx        !: ???
+   REAL(wp), PUBLIC, DIMENSION(jptides_max) ::   tide_speed   !: Phase speed of tidal constituent (deg/hr)
    
-   REAL(wp), DIMENSION(jpbdim,jptides_max)  ::   ssh1, ssh2   !: Tidal constituents : SSH
-   REAL(wp), DIMENSION(jpbdim,jptides_max)  ::   u1  , u2     !: Tidal constituents : U
-   REAL(wp), DIMENSION(jpbdim,jptides_max)  ::   v1  , v2     !: Tidal constituents : V
+   REAL(wp), DIMENSION(jpbdim,jptides_max)  ::   ssh1, ssh2   ! Tidal constituents : SSH
+   REAL(wp), DIMENSION(jpbdim,jptides_max)  ::   u1  , u2     ! Tidal constituents : U
+   REAL(wp), DIMENSION(jpbdim,jptides_max)  ::   v1  , v2     ! Tidal constituents : V
    
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.0 , LOCEAN-IPSL (2008) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
@@ -87,9 +87,11 @@
       !                                               ! Count number of components specified
       ntide = jptides_max
-      itide = 1
-      DO WHILE( tide_cpt(itide) /= '' )
-         ntide = itide
-         itide = itide + 1
+      DO itide = 1, jptides_max
+        IF( tide_cpt(itide) == '' ) THEN
+           ntide = itide-1
+           exit
+        ENDIF
       END DO
+
       !                                               ! find constituents in standard list
       DO itide = 1, ntide
@@ -145,5 +147,5 @@
       CHARACTER(len=80) :: clfile         ! full file name for tidal input file 
       INTEGER ::   ipi, ipj, inum, idvar  ! temporary integers (netcdf read)
-      INTEGER, DIMENSION(3) :: lendta=0   ! length of data in the file (note may be different from nblendta!)
+      INTEGER, DIMENSION(6) :: lendta=0   ! length of data in the file (note may be different from nblendta!)
       REAL(wp) ::  z_arg, z_atde, z_btde, z1t, z2t           
       REAL(wp), DIMENSION(jpbdta,1) ::   zdta   ! temporary array for data fields
@@ -161,5 +163,5 @@
          IF(lwp) WRITE(numout,*) 'Reading data from file ', clfile
          CALL iom_open( clfile, inum )
-         igrd = 1
+         igrd = 4
          IF( nblendta(igrd) <= 0 ) THEN 
             idvar = iom_varid( inum,'z1' )
@@ -183,5 +185,5 @@
          IF(lwp) WRITE(numout,*) 'Reading data from file ', clfile
          CALL iom_open( clfile, inum )
-         igrd = 2
+         igrd = 5
          IF( lendta(igrd) <= 0 ) THEN 
             idvar = iom_varid( inum,'u1' )
@@ -204,5 +206,5 @@
          if(lwp) write(numout,*) 'Reading data from file ', clfile
          CALL iom_open( clfile, inum )
-         igrd = 3
+         igrd = 6
          IF( lendta(igrd) <= 0 ) THEN 
             idvar = iom_varid( inum,'v1' )
@@ -252,5 +254,5 @@
             ENDIF
             !                                         !  elevation         
-            igrd = 1
+            igrd = 4
             DO ib = 1, nblenrim(igrd)                
                z1t = z_atde * ssh1(ib,itide) + z_btde * ssh2(ib,itide)
@@ -260,5 +262,5 @@
             END DO
             !                                         !  u       
-            igrd = 2
+            igrd = 5
             DO ib = 1, nblenrim(igrd)                
                z1t = z_atde * u1(ib,itide) + z_btde * u2(ib,itide)
@@ -268,5 +270,5 @@
             END DO
             !                                         !  v       
-            igrd = 3
+            igrd = 6
             DO ib = 1, nblenrim(igrd)                
                z1t = z_atde * v1(ib,itide) + z_btde * v2(ib,itide)
@@ -320,15 +322,15 @@
       !
       DO itide = 1, ntide
-         igrd=1                              ! SSH on tracer grid.
+         igrd=4                              ! SSH on tracer grid.
          DO ib = 1, nblenrim(igrd)
             sshtide(ib) =sshtide(ib)+ ssh1(ib,itide)*z_cost(itide) + ssh2(ib,itide)*z_sist(itide)
             !    if(lwp) write(numout,*) 'z',ib,itide,sshtide(ib), ssh1(ib,itide),ssh2(ib,itide)
          END DO
-         igrd=2                              ! U grid
+         igrd=5                              ! U grid
          DO ib=1, nblenrim(igrd)
             utide(ib) = utide(ib)+ u1(ib,itide)*z_cost(itide) + u2(ib,itide)*z_sist(itide)
             !    if(lwp) write(numout,*) 'u',ib,itide,utide(ib), u1(ib,itide),u2(ib,itide)
          END DO
-         igrd=3                              ! V grid
+         igrd=6                              ! V grid
          DO ib=1, nblenrim(igrd)
             vtide(ib) = vtide(ib)+ v1(ib,itide)*z_cost(itide) + v2(ib,itide)*z_sist(itide)
Index: trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdytra.F90	(revision 2528)
@@ -11,5 +11,5 @@
    !!   'key_bdy'                     Unstructured Open Boundary Conditions
    !!----------------------------------------------------------------------
-   !!   bdy_tra        : Relaxation of tracers on unstructured open boundaries
+   !!   bdy_tra_frs        : Relaxation of tracers on unstructured open boundaries
    !!----------------------------------------------------------------------
    USE oce             ! ocean dynamics and tracers variables
@@ -22,17 +22,16 @@
    PRIVATE
 
-   PUBLIC bdy_tra     ! routine called in tranxt.F90 
+   PUBLIC bdy_tra_frs     ! routine called in tranxt.F90 
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.0 , LOCEAN-IPSL (2008) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
-   SUBROUTINE bdy_tra( kt )
+   SUBROUTINE bdy_tra_frs( kt )
       !!----------------------------------------------------------------------
-      !!                 ***  SUBROUTINE bdy_tra  ***
+      !!                 ***  SUBROUTINE bdy_tra_frs  ***
       !!                    
       !! ** Purpose : Apply the Flow Relaxation Scheme for tracers in the  
@@ -48,29 +47,28 @@
       !!----------------------------------------------------------------------
       !
-      IF(ln_bdy_tra_frs) THEN ! If this is false, then this routine does nothing. 
-
-      IF( kt == nit000 ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'bdy_tra : Flow Relaxation Scheme for tracers'
-         IF(lwp) WRITE(numout,*) '~~~~~~~'
-      ENDIF
+      IF(ln_tra_frs) THEN       ! If this is false, then this routine does nothing. 
+         !
+         IF( kt == nit000 ) THEN
+            IF(lwp) WRITE(numout,*)
+            IF(lwp) WRITE(numout,*) 'bdy_tra_frs : Flow Relaxation Scheme for tracers'
+            IF(lwp) WRITE(numout,*) '~~~~~~~'
+         ENDIF
+         !
+         igrd = 1                       ! Everything is at T-points here
+         DO ib = 1, nblen(igrd)
+            DO ik = 1, jpkm1
+               ii = nbi(ib,igrd)
+               ij = nbj(ib,igrd)
+               zwgt = nbw(ib,igrd)
+               ta(ii,ij,ik) = ( ta(ii,ij,ik) * (1.-zwgt) + tbdy(ib,ik) * zwgt ) * tmask(ii,ij,ik)         
+               sa(ii,ij,ik) = ( sa(ii,ij,ik) * (1.-zwgt) + sbdy(ib,ik) * zwgt ) * tmask(ii,ij,ik)
+            END DO
+         END DO 
+         !
+         CALL lbc_lnk( ta, 'T', 1. )   ; CALL lbc_lnk( sa, 'T', 1. )    ! Boundary points should be updated
+         !
+      ENDIF ! ln_tra_frs
       !
-      igrd = 1                       ! Everything is at T-points here
-      DO ib = 1, nblen(igrd)
-         DO ik = 1, jpkm1
-            ii = nbi(ib,igrd)
-            ij = nbj(ib,igrd)
-            zwgt = nbw(ib,igrd)
-            ta(ii,ij,ik) = ( ta(ii,ij,ik) * (1.-zwgt) + tbdy(ib,ik) * zwgt ) * tmask(ii,ij,ik)         
-            sa(ii,ij,ik) = ( sa(ii,ij,ik) * (1.-zwgt) + sbdy(ib,ik) * zwgt ) * tmask(ii,ij,ik)
-        END DO
-      END DO 
-      !
-      CALL lbc_lnk( ta, 'T', 1. )   ! Boundary points should be updated
-      CALL lbc_lnk( sa, 'T', 1. )   !
-      !
-      ENDIF ! ln_bdy_tra_frs
-
-   END SUBROUTINE bdy_tra
+   END SUBROUTINE bdy_tra_frs
    
 #else
@@ -79,7 +77,7 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   SUBROUTINE bdy_tra(kt)      ! Empty routine
-      WRITE(*,*) 'bdy_tra: You should not have seen this print! error?', kt
-   END SUBROUTINE bdy_tra
+   SUBROUTINE bdy_tra_frs(kt)      ! Empty routine
+      WRITE(*,*) 'bdy_tra_frs: You should not have seen this print! error?', kt
+   END SUBROUTINE bdy_tra_frs
 #endif
 
